// Program Listing 4.5 - Basic Servo Control myservo and SR04 demo
//had problems with using daul pwm and sfr04=--need to use pwm start/stop

import stamp.core.*;
import stamp.peripheral.sensor.range.SRF04;
public class myservo1 {
//pan settings for servo at pin 12
   static int rightmost= 130;
   static int leftmost= 220;
   static int center =172;
//titl setting for servo at pin 13
   static int up= 95;
   static int down= 185;
   static int middle =120;

  final static char CLR_SCR = '\u0010';
// create message buffer for screen display

// measurement from SRF04
static StringBuffer msg = new StringBuffer();
static   SRF04 range = new SRF04(CPU.pin8, CPU.pin9);
static   PWM pan = new PWM(CPU.pin12,173,2304);
static  PWM tilt = new PWM(CPU.pin13,173,2304);
static  int distance;
static void clr_screen() {
  msg.clear();
  msg.append(CLR_SCR);


}
static void getRange() {
 pan.stop();    //this is necessary for SFR to work
 tilt.stop();
   //     CPU.removeVP(tilt);

    distance = range.getIn10();
    msg.append(" ");
    if (distance > 0) {
    msg.append(distance / 10); // whole part
    msg.append( ".");
    msg.append(distance % 10); // fractional part
    }
    else
   msg.append("Out of Range");
    msg.append("\n");
    System.out.print(msg.toString());
   pan.start();     //restart vps
  tilt.start();
   CPU.delay(10000);


}
  public static void main() {



    int temp =0;
    System.out.println("Welcome to Servo Control: ");
    System.out.println(" r -  pan right");
    System.out.println(" l -  pan left");
    System.out.println(" c -  pan center");
    System.out.println(" u - tilt  up");
    System.out.println(" d - tilt down");
    System.out.println(" m - tilt middle");
    System.out.println(" p - pan front center");
    System.out.println(" b - pan front floor");
    System.out.println(" t - pan front ceiling");
    System.out.println(" z -tilt up to down");



    while (true) {
    //    clr_screen();
   //   getRange();
      switch ( Terminal.getChar() ) {
      case 'r':
        pan.update(rightmost,2304);
          msg.clear();
        msg.append( "pan right ");
        getRange();
        break;

      case 'l':
        pan.update(leftmost,2304);
          msg.clear();
          msg.append( "pan left ");
        getRange();
        break;

      case 'c':
        pan.update(center,2304);
          msg.clear();
        msg.append( "pan center ");
        getRange();
        break;

       case 'u':
        tilt.update(up,2304);
          msg.clear();
        msg.append( "tilt up ");
        getRange();
        break;

      case 'd':
        tilt.update(down,2304);
          msg.clear();
        msg.append( "tilt down ");
        getRange();
        break;

      case 'm':
        tilt.update(middle,2304);
          msg.clear();
        msg.append( "tilt center  ");
        getRange();
        break;

        case 'p':
         tilt.update(middle,2304); //set to middle
         CPU.delay(5000);   //1/2 sec
        pan.update(rightmost,2304);
         CPU.delay(5000);   //1/2 sec
         //leftmost -rightmost = range 220-130 =90
         temp =rightmost;
         for (int i =0; i<4; i++)
         {

          pan.update(temp,2304);
         CPU.delay(10000);   //1 sec
           temp =temp+30;
           //this add range and pan pos to screen
           msg.append("pan c ="+temp);
           getRange();
         }
        break;
         case 'b':
         tilt.update(down,2304); //set to middle
         CPU.delay(5000);   //1/2 sec
        pan.update(rightmost,2304);
         CPU.delay(5000);   //1/2 sec
         //leftmost -rightmost = range 220-130 =90
         temp =rightmost;
         for (int i =0; i<4; i++)
         {

          pan.update(temp,2304);
         CPU.delay(10000);   //1 sec
           temp =temp+30;
           msg.append("pan flr ="+temp);
           getRange();
         }
        break;
          case 't':
         tilt.update(up,2304); //set to middle
         CPU.delay(5000);   //1/2 sec
        pan.update(rightmost,2304);
         CPU.delay(5000);   //1/2 sec
         //leftmost -rightmost = range 220-130 =90
         temp =rightmost;
         for (int i =0; i<4; i++)
         {

          pan.update(temp,2304);
         CPU.delay(10000);   //1 sec
           temp =temp+30;
           msg.append("pan roof ="+temp);
          getRange();
         }
        break;
           case 'z':


        tilt.update(up,2304);
         CPU.delay(5000);   //1/2 sec
         //up -down = range 95-185
         temp =up;
         for (int i =0; i<9; i++)
         {

          tilt.update(temp,2304);
         CPU.delay(10000);   //1 sec
           temp =temp+10;
            msg.append("tilt u-d ="+temp);
           getRange();
         }
        break;
      }

  // delay
  CPU.delay(10000);

    }
  }
}